//---------------------------------------------------------------------------
//
//   ExportASE
//
//    @ASE`o͂GNX|[gvOCB
//		CZXMITCZXłB
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "MQPlugin.h"
#include "MQ3DLib.h"

BOOL SaveASE(const char *filename, MQDocument doc);


//---------------------------------------------------------------------------
//  DllMain
//---------------------------------------------------------------------------
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	//vOCƂĂ͓ɕKvȏ͂Ȃ̂ŁATRUEԂ
    return TRUE;
}

//---------------------------------------------------------------------------
//  MQGetPlugInID
//    vOCIDԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT void MQGetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	*Product = 0x54D31E20;
	*ID      = 0x45501A0D;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//    vOCԂB
//    ̊֐[vOCɂ]\ɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQGetPlugInName(void)
{
	// vOC
	return "ASE Exporter ver0.1 Copyright(C) Doraya";
}

//---------------------------------------------------------------------------
//  MQGetPlugInType
//    vOC̃^CvԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT int MQGetPlugInType(void)
{
	// o͗pvOCł
	return MQPLUGIN_TYPE_EXPORT;
}

//---------------------------------------------------------------------------
//  MQEnumFileType
//    ͂܂͏o͉\ȃt@C^CvԂB
//    t@C^Cv͕ʖۑ̃_CAOɕ\B
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumFileType(int index)
{
	switch(index){
	case 0: return "Ascii Scene Export(*.ase)";
	// ̃^CvT|[gꍇ͈ȉ̂悤ɂ΂悢ÃTv
	// ł͎ĂȂ߁ARgAEg
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQEnumFileExt
//    ͂܂͏o͉\ȊgqԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumFileExt(int index)
{
	switch(index){
	case 0: return "ase";
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQExportFile
//    [ʖŕۑ]ŕۑƂɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT BOOL MQExportFile(int index, const char *filename, MQDocument doc)
{
	switch(index){
	case 0: return SaveASE(filename, doc);
	//case 1: return Save3DS(filename, doc);
	}
	return FALSE;
}

//===========================================================================================================================
// ASE`ŏo
BOOL SaveASE(const char *filename, MQDocument doc)
{
	int i, face_index, index[4], mat_index, x, j, uvindex[4], n;
	MQMaterial mat;

	MQFileDialogInfo dlginfo;
	char path1[MAX_PATH], mat_name[64];
	char path2[MAX_PATH], obj_name[64];

	// t@C쐬EI[v
	FILE *fh = fopen(filename, "w");
	if(fh == NULL)
		return FALSE;

	// Wϊp_CAO̕\
	memset(&dlginfo, 0, sizeof(dlginfo));
	dlginfo.dwSize = sizeof(dlginfo);
	dlginfo.axis_x = MQFILE_TYPE_LEFT;
	dlginfo.axis_y = MQFILE_TYPE_DOWN;
	dlginfo.axis_z = MQFILE_TYPE_FRONT;
	dlginfo.softname = "3D Studio";
	MQ_ShowFileDialog("ASC Export", &dlginfo);

	// IuWFNg̐𓾂
	int obj_count = doc->GetObjectCount();

	// ̃IuWFNgPɍ邽߂ɁAƗpIuWFNg쐬
	MQObject obj = MQ_CreateObject();
	MQObject currentobj = MQ_CreateObject();


	// ƗpIuWFNgɂׂẴIuWFNg
	for(i=0; i<obj_count; i++)
	{
		MQObject thisobj = doc->GetObject(i);
		if(thisobj == NULL) 
			continue;
		// t[YȂǂɂeύXĂ܂̂ŁAIuWFNg𕡐Ă
		thisobj = thisobj->Clone();
		// ȖʂȂǂ̑t[Y
		thisobj->Freeze(MQOBJECT_FREEZE_ALL);
		// ƗpIuWFNgɍ
		obj->Merge(thisobj);
		// IuWFNg͂svȂ̂Ŕj
		thisobj->DeleteThis();
	}

	//=============================================================================
	int mat_count = doc->GetMaterialCount();
	int *mat_used = (int *)malloc(sizeof(int) * (mat_count+1));

	int matID=0;
	//=============================================================================
	// t@CɃf[^
	fprintf(fh, "*3DSMAX_ASCIIEXPORT 200\n");
	fprintf(fh, "*COMMENT \"Metasequoia ASE Export ver0.1 by Doraya\"\n");

	//V[n@Aj̐ݒۂ̂Ŕ΂
	//fprintf(fh, "*SCENE {\n");
	//fprintf(fh, "	*SCENE_FILENAME \"\"\n");
	//fprintf(fh, "}\n");

	//}eA
	fprintf(fh, "*MATERIAL_LIST {\n");
	fprintf(fh, "	*MATERIAL_COUNT 1\n");
	fprintf(fh, "	*MATERIAL 0 {\n");
	fprintf(fh, "			*MATERIAL_NAME \"Multi/Sub_Object\"\n");
	fprintf(fh, "			*NUMSUBMTLS %d\n",mat_count);

	//}eA
	for(mat_index=0; mat_index<=mat_count-1; mat_index++)
	{
		int mi;

		// ̍ގgĂȂ΃pX
		if(mat_used[mat_index] == 0)
		continue;
		if(mat_index == mat_count)
		{
			mi = -1;
		}
		else
		{
			mat = doc->GetMaterial(mat_index);
			mi = mat_index;
		}

		mat->GetName(mat_name, sizeof(mat_name));
		fprintf(fh, "			*SUBMATERIAL %d {\n",mat_index);
		fprintf(fh, "				*MATERIAL_NAME \"%s\"\n", mat_name);
		fprintf(fh, "				*MATERIAL_CLASS \"Standard\"\n");
		fprintf(fh, "				*MAP_DIFFUSE {\n");
		fprintf(fh, "				*MAP_CLASS \"Bitmap\"\n");
		fprintf(fh, "				*BITMAP \"None\"\n");
		fprintf(fh, "				*UVW_U_OFFSET 0\n");
		fprintf(fh, "				*UVW_V_OFFSET 0\n");
		fprintf(fh, "				*UVW_U_TILING 1\n");
		fprintf(fh, "				*UVW_V_TILING 1\n");
		fprintf(fh, "				}\n");
		fprintf(fh, "			}\n");
	}

	fprintf(fh, "		}\n");
	fprintf(fh, "}\n");

//===========================================
//WIgFor͂
//===========================================

	//=============================================================================
	int z = 0;
	//=============================================================================

for(x=0; x<obj_count; x++, z++)
{
	//WIg
	MQObject dummyobj = MQ_CreateObject();
	MQObject dummyobj2 = MQ_CreateObject();
	dummyobj = doc->GetObject(z);
	dummyobj = dummyobj->Clone();
	dummyobj->Freeze(MQOBJECT_FREEZE_ALL);
	currentobj->Merge(dummyobj);

	dummyobj2->DeleteThis();

	if(currentobj == NULL) 
			continue;

	// ʂƒ_̐擾
	int face_count = currentobj->GetFaceCount();
	int vert_count = currentobj->GetVertexCount();

	// ASE`͎Op`Ȃ̂ŁAOp`ʂ͂PAlp`ʂ͂QƂāA
	// o͌̎Opʂ̐𐔂
	int triangle_count = 0;
	for(face_index=0; face_index<face_count; face_index++)
	{
		switch(currentobj->GetFacePointCount(face_index)){
		case 3: triangle_count++; break;
		case 4: triangle_count+=2; break;
		}
	}
	
	dummyobj->GetName(obj_name, sizeof(obj_name));	
	dummyobj->DeleteThis();

	fprintf(fh, "*GEOMOBJECT {\n");
	fprintf(fh, "	*NODE_NAME \"%s\"\n",obj_name);
	fprintf(fh, "	*NODE_TM {\n");
	fprintf(fh, "		*NODE_NAME \"%s\"\n",obj_name);
	fprintf(fh, "	}\n");

	fprintf(fh, "	*MESH {\n");
	fprintf(fh, "		*MESH_NUMVERTEX %d\n",vert_count);
	fprintf(fh, "		*MESH_NUMFACES %d\n",triangle_count);

	//=======================================
	//_Xg
	fprintf(fh, "		*MESH_VERTEX_LIST {\n");

	// _̃f[^zƂptsɊi[
	MQPoint *pts = (MQPoint *)malloc(sizeof(MQPoint) * vert_count);
	currentobj->GetVertexArray(pts);
	// W_CAOŎw肵̂ɕϊ
	MQ_ExportAxis(&dlginfo, pts, vert_count);

	// t@C֏o
	for(i=0; i<vert_count; i++)
		fprintf(fh, "			*MESH_VERTEX %d	%.4f %.4f %.4f\n",
			i, pts[i].y, pts[i].x, pts[i].z);
	free(pts);

	fprintf(fh, "		}\n");

	//======================================
	// ʃXg̏
	fprintf(fh, "		*MESH_FACE_LIST {\n");

	triangle_count = 0;

	MQObject smoothobj = MQ_CreateObject();
	smoothobj = doc->GetObject(z);

	float smoothvalue;
	int smoothingID;
	smoothingID=0;
	smoothvalue = smoothobj->GetSmoothAngle();

	for(face_index=0; face_index<face_count; face_index++)
	{
		currentobj->InvertFace(face_index);

		// _CfbNX̔z𓾂
		currentobj->GetFacePointArray(face_index, index);
		// ގCfbNX𓾂(Fʂ-1Ԃ)
		mat_index = currentobj->GetFaceMaterial(face_index);
		mat = (mat_index >= 0) ? doc->GetMaterial(mat_index) : NULL;

		MQObjNormal *normal2 = new MQObjNormal(currentobj);	
		int f;
		f=0;

		if(face_count==face_index)
		{
			f=face_index+1;
		}
		else
		{
			f=0;
		}

		//m[}擾
		MQPoint nv3 = normal2->Get(face_index, 0);
		MQPoint nv4 = normal2->Get(f, 0);

		float facenormalA;
		float facenormalB;

		facenormalA=nv3.x;
		facenormalB=nv4.x;

		// Op`ʂ͂PAlp`ʂ͂Q̖ʂ
		switch(currentobj->GetFacePointCount(face_index))
		{
		case 3:

			if(facenormalA+facenormalB<smoothvalue*0.01)
			{
				smoothingID=1;
			}
			else
			{
				smoothingID=1;
			}

			fprintf(fh, "			*MESH_FACE	%d:	A:	%d	B:	%d	C:	%d	",
				triangle_count++, index[0], index[1], index[2]);

			fprintf(fh, "	*MESH_SMOOTHING %d",smoothingID);
			fprintf(fh, "	*MESH_MTLID %d\n",mat_index);

			break;

		case 4:

			if(facenormalA+facenormalB<smoothvalue*0.01)
			{
				smoothingID=1;
			}
			else
			{
				smoothingID=1;
			}

			// (0-1-2)𒸓_CfbNXƂOp`̏o
			fprintf(fh, "			*MESH_FACE	%d:	A:	%d	B:	%d	C:	%d	",
				triangle_count++, index[0], index[1], index[2]);
			
			fprintf(fh, " *MESH_SMOOTHING %2f",smoothingID);
			fprintf(fh, "	*MESH_MTLID %d\n",mat_index);

			
			// (0-2-3)𒸓_CfbNXƂOp`̏o
			fprintf(fh, "			*MESH_FACE	%d:	A:	%d	B:	%d	C:	%d	",
				triangle_count++, index[0], index[2], index[3]);
			
			fprintf(fh, " *MESH_SMOOTHING %2f",smoothingID);
			fprintf(fh, "	*MESH_MTLID %d\n",mat_index);
			break;

		}
		delete normal2;
	}

	fprintf(fh, "		}\n");

	//====================================
	//eNX`UV
	//====================================
	MQCoordinate uv_array[4];
	int l;
	int count;
	float dummynum;
	dummynum=0;
	j=0;
	l=0;
	int uv_count=triangle_count*3;


	fprintf(fh, "		*MESH_NUMTVERTEX %d\n",uv_count);
	fprintf(fh, "		*MESH_TVERTLIST {\n");
	//=====================================
	//MESH_TVERTLIST for
	//=====================================

	for(j=0; l<uv_count; j++)
	{
		// _CfbNX̔z𓾂
		currentobj->GetFaceCoordinateArray(j, uv_array);

		switch(currentobj->GetFacePointCount(j))
		{
			case 3:

				fprintf(fh, "			*MESH_TVERT	%d	%.4f	%.4f	%.4f\n", l, uv_array[0].u, uv_array[0].v*-1, dummynum);
				l++;
				fprintf(fh, "			*MESH_TVERT	%d	%.4f	%.4f	%.4f\n", l, uv_array[1].u, uv_array[1].v*-1, dummynum);
				l++;
				fprintf(fh, "			*MESH_TVERT	%d	%.4f	%.4f	%.4f\n", l, uv_array[2].u, uv_array[2].v*-1, dummynum);
				l++;
				break;

			case 4:

				fprintf(fh, "			*MESH_TVERT	%d	%.4f	%.4f	%.4f\n", l, uv_array[0].u, uv_array[0].v*-1, dummynum);
				l++;
				fprintf(fh, "			*MESH_TVERT	%d	%.4f	%.4f	%.4f\n", l, uv_array[1].u, uv_array[1].v*-1, dummynum);
				l++;
				fprintf(fh, "			*MESH_TVERT	%d	%.4f	%.4f	%.4f\n", l, uv_array[2].u, uv_array[2].v*-1, dummynum);
				l++;

				fprintf(fh, "			*MESH_TVERT	%d	%.4f	%.4f	%.4f\n", l, uv_array[0].u, uv_array[0].v*-1, dummynum);
				l++;
				fprintf(fh, "			*MESH_TVERT	%d	%.4f	%.4f	%.4f\n", l, uv_array[2].u, uv_array[2].v*-1, dummynum);
				l++;
				fprintf(fh, "			*MESH_TVERT	%d	%.4f	%.4f	%.4f\n", l, uv_array[3].u, uv_array[3].v*-1, dummynum);
				l++;
				break;
		}
	}

	//=====================================
	//MESH_TVERTLIST for@I
	//=====================================
	fprintf(fh, "		}\n");

	fprintf(fh, "		*MESH_NUMTVFACES %d\n",triangle_count);
	fprintf(fh, "		*MESH_TFACELIST {\n");
	//=====================================
	//MESH_TFACELIST for
	//=====================================
	int y=0;
	for(face_index=0; face_index<triangle_count; face_index++)
	{
		// _CfbNX̔z𓾂
		currentobj->GetFacePointArray(face_index, index);

	fprintf(fh, "			*MESH_TFACE %d",face_index);
		fprintf(fh, "	%d",y++);
		fprintf(fh, "	%d",y++);
		fprintf(fh, "	%d\n",y++);
	}
	//=====================================
	//MESH_TFACELIST for@I
	//=====================================
	fprintf(fh, "		}\n");

	fprintf(fh, "		*MESH_NUMCVERTEX 0\n");

	//===============================================================================
	fprintf(fh, "		*MESH_NORMALS {\n");
	//=====================================
	//MESH_NORMALS for
	//=====================================
//	 @̌vZ
	MQObjNormal *normal = new MQObjNormal(currentobj);	
	int pt, face;

	for(face=0;face<triangle_count; face++)
	{
		//m[}擾
		MQPoint nv = normal->Get(face, 1);
		//ʂ̒_z擾
		currentobj->GetFacePointArray(face, index);
		
		fprintf(fh, "			*MESH_FACENORMAL %d	%.4f	%.4f	%.4f\n", face, nv.x, nv.y, nv.z);
		
		for(pt=2; pt>-1; pt--)
		{
			MQPoint nv2 = normal->Get(face, pt);
			fprintf(fh, "				*MESH_VERTEXNORMAL %d	%.4f	%.4f	%.4f\n", index[pt], nv2.x, nv2.y, nv2.z);
		}
	}
	delete normal;
	//=====================================
	//MESH_NORMALS for@I
	//=====================================

	fprintf(fh, "		}\n");

	//===============================================================================

	fprintf(fh, "	}\n");

	fprintf(fh, "	*MATERIAL_REF 0\n");
	fprintf(fh, "}\n");	

	// IuWFNg͂svȂ̂Ŕj
	currentobj->DeleteThis();
}
//===========================================
//WIgForI
//===========================================

	// ƗpIuWFNgj
	obj->DeleteThis();

	// t@CN[Y
	fclose(fh);

	return TRUE;
}

